#include "echonormalizer.h"
#include "stree.h"
#include "streeconstant.h"

Node* EchoNormalizer::transform(Node *node) const{
/*  if (node->getName() != CStatementList)*/ return node;

  StatementList *statementList = dynamic_cast<StatementList *>(node);
  // TODO : zmienic "Echo" na CEcho i inne takie

  StatementList new_list;
#ifdef ciebie_debug
  cout << "Normalizing statement list: BEGIN" << endl;
#endif
  StatementList::const_iterator it = statementList->begin();
  StatementList::const_iterator eit = statementList->end();
  while (it!=eit){
    if (((*it)->getName() == "Echo") && 
	(dynamic_cast<Echo*>(*it)->front()->getName() == "ExpressionList"))
      {
#ifdef ciebie_debug
	cout << "ECHO" << endl;
#endif
	Echo *l = dynamic_cast<Echo*>(*it);
	ExpressionList *e = dynamic_cast<ExpressionList*>(l->front());
	list<Node*>::iterator nl = e->begin();
	list<Node*>::iterator enl = e->end();
	while (nl!=enl) {
	  if ((*nl)->getName() == "DoubleQuote") {
	    EncapsList *e = dynamic_cast<EncapsList*>(dynamic_cast<DoubleQuote*>(*nl)->front());
	    list<Node*>::iterator nl = e->begin();
	    list<Node*>::iterator enl = e->end();
	    while (nl!=enl) {
	      if (((*nl)->getName() == "Constant") && (dynamic_cast<Constant*>(*nl)->getValue()[0] == '$'))
		new_list.push_back(new Echo(new ExpressionList(new DoubleQuote(*nl))));
	      else 
		new_list.push_back(new Echo(new ExpressionList((*nl))));
	      nl++;
	    }

	  } else {
	    new_list.push_back(new Echo(new ExpressionList(*nl)));	  
#ifdef ciebie_debug
	    cout << "New ECHO " << (*nl)->getName() << endl;
#endif
	  }
	  nl++;
	}
      }
    else
      {
	new_list.push_back(*it);
      }
    it++;
  };
  statementList->clear();
  swap(*statementList,new_list);
  /*
  while (!new_list.empty()) {
    statementList->push_back(new_list.front());
    new_list.pop_front();
    }
  */
#ifdef ciebie_debug
  cout << "Normalizing statement list: END" << endl;
#endif
  return node;
};
