#include "htmlbox.h"
#include <fstream>
#include <sstream>
#include <iostream>
//#include <boost/regex.hpp>

Node* HTMLBox::Putter::transform(Node* node) const{
  if (node->getName() == CInlineHTML){
    InlineHTML *inlineHTML = dynamic_cast<InlineHTML*>(node);	
    htmlBox.putHTML(inlineHTML->getHTML());
  }
  return node;
};

Node* HTMLBox::Replacer::transform(Node* node) const{
  if (node->getName() == CInlineHTML){
    InlineHTML *inlineHTML = dynamic_cast<InlineHTML*>(node);
    inlineHTML->setHTML(htmlBox.getHTML(inlineHTML->getHTML()));
  }
  return node;
};


string HTMLBox::generateIncludeName(){
  usedNames++;
  stringstream str;
  str << "include" << usedNames << ".tpl";
  return str.str();
};

/// Normalizes html
/*!
  lowercases <tags> and removes unnaccesary whitespaces
*/

//#define ciebie_debug
string HTMLBox::normalize(const string &html)
{
  /*
 boost::regex e;
 string norm;
 //TODO: lowercase of tags
 try
   {
     e.assign("([[:space:]]+)");
   }
 catch (...)
   {
     cout << "Zepsute wyrazenie regularne" << endl;
     exit(-1);
   }
#ifdef ciebie_debug
 cout << "Normalizing " << html << "gives" <<
   boost::regex_merge(html, e, "(?1 )") << endl;
   #endif*/
  return html;
}



/// Puts html into the box
/*!
  When html appears more than once an include file is generated, and
  the html is changed to include statement.
*/

void HTMLBox::putHTML(const string &html){
  normalize(html);
  switch (collectedHTML[html].occurences){
  case 0:
    collectedHTML[html].html = html;
    collectedHTML[html].occurences++;
    break;
  case 1:{
    string includeName = generateIncludeName();
    ofstream includeOfs((outDir+includeName).c_str());
    includeOfs << collectedHTML[html].html;
    collectedHTML[html].html = "{include file=\"" +includeName + "\"}";
    collectedHTML[html].occurences++;
  }
    break;
  default:
    collectedHTML[html].occurences++;
  }
}

void HTMLBox::regenerate()
{
  regenerated = 1;
  cout << "Regenerating" << endl;
};

/// Returns refactored html.
string HTMLBox::getHTML(const string &html){
  if (regenerated == 0) regenerate();
  return collectedHTML[html].html;
};


