#ifndef _NAMEDCONTEXT_H_
#define _NAMEDCONTEXT_H_
#include "rulecontext.h"


/// Conetex that runs the given rule list.
class NamedContext : public RuleContext{  
 public:
  /// context name
  const string name;
  
  /// super context
  RuleContext* superContext;

  /// Stores the number of assigned variale names.
  int usedNames;

  /// List of smart varriables.
  typedef set<string> SmartyVariableList;

  /// Stores registered smaryt variables.
  SmartyVariableList smartyVariableList;

 public:
  /// Constructor
  NamedContext(const string &iname, RuleList &irules, NameSpace &inameSpace); 

  virtual void generateVariableNames(const Node::VariableList &vlist, Node::Assignment &phpAssign, Node::Assignment &tplAssign);

  virtual const string getVariableNamePrefix();

  virtual const string getVariableNameSufix(const bool stripControlVariableDollar);

  virtual const string generateVariableName() ; 

  virtual void registerSmartyVariable(const string &variable);

  virtual void processSmartyAssign(SmartyAssign *smartyAssign);

  virtual void leaveContext(List *phpOut, List *tplOut);

  virtual void processTemplate(Node* tpl) const;
};

#endif
