#ifndef _RTREECONTEXTRULE_H_
#define _RTREECONTEXTRULE_H_

#include "rulecontext.h"

/// Rule that creates a new context for processing inner statement lists.
class ContextRule : public Rule{
 protected:
  /// php in pattern
  List* phpInPattern;
  /// tpl in pattern
  /*!
    Folowing items may appear in this list:
    - Template -- only substitutions are made,
    - Variable -- a subcontext is created and statements matched to his
                  variable are refactored in this context.
   */
  List* tplOutPattern;
  /// php out pattern
  List* phpOutPattern;
 public:
  /// constructor
  ContextRule(List* iphpInPattern, List* itplOutPattern, List* iphpOutPattern) ;
  
  /// destructor
  virtual ~ContextRule();

  virtual bool execute(RuleContext* context, List* phpIn, List* phpOut, List* tplOut, Node::Assignment& assign) const;

  virtual Rule* substitute(const Node::Assignment &assign);

  /// Generates a new subcontext 
  virtual RuleContext* generateSubcontext(RuleContext *context, const Node::Assignment &assign) const = 0;
};


#endif
