#ifndef _RTREEINCLUDERULE_H_
#define _RTREEINCLUDERULE_H_

#include "rtreecontextrule.h"

/// Used for including rules from other files 
class IncludeRule : public Rule{
  
 private:
  /// A name of the rules to include
  const string name;
  /// The referece to rulelist in RuleSystem
  RunRuleList &runRuleList;

 public:
  /// Constructor
  IncludeRule(Constant* iname, RunRuleList &irunRuleList); 

  virtual ~IncludeRule();
  
  virtual bool execute(RuleContext* context, List* phpIn, List* phpOut, List* tplOut, Node::Assignment& assign) const;

  virtual Rule* copy();

  virtual Rule* substitute(const Node::Assignment &assign);
  
  virtual ostream& print(ostream& os) const;
};


#endif
