#include "rtreemulticontextrule.h"
#include "multicontext.h"

MultiContextRule::MultiContextRule(List* iphpInPattern, Variable* icontrolVariable, List* itplOutPattern, List* iphpOutPattern) :
    ContextRule(iphpInPattern,itplOutPattern,iphpOutPattern), controlVariable(icontrolVariable) {};

MultiContextRule::~MultiContextRule(){
  delete controlVariable;
};

RuleContext* MultiContextRule::generateSubcontext(RuleContext *context, const Node::Assignment &assign) const {
  const Node::Assignment::const_iterator controlVarialbeMatchedPair= assign.find(controlVariable->getId());
  if (controlVarialbeMatchedPair == assign.end()){
    cout << "A" << endl;
    return new MultiContext(context, controlVariable->getId());
  } else {
    const Node* controlVariableMatched = controlVarialbeMatchedPair->second;
    if (controlVariableMatched->getName()!=CPHPVariable)
      throw "ERROR: MultiContextRule::generateSubcontext - control variable is not given by constant";
    const PHPVariable* phpVariable = dynamic_cast<const PHPVariable*>(controlVariableMatched);
    return new MultiContext(context, controlVariable->getId(), 
			    dynamic_cast<const Constant*>(phpVariable->getStatement1())->getValue());
  };
};
  
ostream& MultiContextRule::print (ostream& os) const{
    os << "MultiContextRule - ";
    phpInPattern->print(os);
    return os;
};

Rule* MultiContextRule::copy(){
  return new MultiContextRule(phpInPattern->copyList(),
			      dynamic_cast<Variable*>(controlVariable->copy()),
			      tplOutPattern->copyList(),
			      phpOutPattern->copyList());
};
