#ifndef _RTREEMULTICONTEXTRULE_H_
#define _RTREEMULTICONTEXTRULE_H_

#include "rtreecontextrule.h"
#include "streevariable.h"

/// Used for refactoring statements that are executed many times e.g. statements in for.
class MultiContextRule : public ContextRule{
  /// The control variable
  Variable* controlVariable;
 public:
  /// Constructor
  MultiContextRule(List* iphpInPattern, Variable* icontrolVariable, List* itplOutPattern, List* iphpOutPattern) ;
  
  virtual ~MultiContextRule();

  virtual Rule* copy();

  virtual RuleContext* generateSubcontext(RuleContext *context, const Node::Assignment &assign) const;
 
  virtual ostream& print (ostream& os) const;
};


#endif

