#include "rtreesinglecontextrule.h"
#include "singlecontext.h"

SingleContextRule::SingleContextRule(List* iphpInPattern, List* itplOutPattern, List* iphpOutPattern) :
    ContextRule(iphpInPattern,itplOutPattern,iphpOutPattern) {};

Rule* SingleContextRule::copy(){
  return new SingleContextRule(phpInPattern->copyList(),
		                tplOutPattern->copyList(),
		                phpOutPattern->copyList());

};

RuleContext* SingleContextRule::generateSubcontext(RuleContext *context, const Node::Assignment &assign) const {
    return new SingleContext(context);
};
  
ostream& SingleContextRule::print (ostream& os) const{
    os << "SingleContextRule - ";
    phpInPattern->print(os);
    return os;
};

