#include "rtreesubstitutionrule.h"

SubstitutionRule::SubstitutionRule(List* iphpInPattern, List* itplOutPattern, List* iphpOutPattern) 
      : phpInPattern(iphpInPattern), tplOutPattern(itplOutPattern), phpOutPattern(iphpOutPattern) {};

bool SubstitutionRule::execute(RuleContext* context, List* phpIn, List* phpOut, List* tplOut,Node::Assignment &assign) const {
      if (phpInPattern->matchToBegining(phpIn,assign,context->getNameSpace())){
	List* phpOutMatched = dynamic_cast<List*>(phpOutPattern->copy());
	phpOutMatched->substitute(assign);
	List* tplOutMatched = dynamic_cast<List*>(tplOutPattern->copy());
	tplOutMatched->substitute(assign);
	//	cout << phpOutMatched << "|" << tplOutMatched << endl;
	// cout << tplOutPattern->copy()->substitute(assign) << endl;
	for (int i=0 ; i<phpInPattern->getLength() ; i++){
	  delete phpIn->front();
	  phpIn->pop_front();
	};
	context->assignVariableNames(phpOutMatched,tplOutMatched);
	phpOut->append(phpOutMatched);
	tplOut->append(tplOutMatched);
	return true;
      }
      return false;
};

Rule* SubstitutionRule::copy(){
  return new SubstitutionRule(phpInPattern->copyList(),
			      tplOutPattern->copyList(),
			      phpOutPattern->copyList());
};

Rule* SubstitutionRule::substitute(const Node::Assignment &assign){
  phpInPattern->substitute(assign);
  tplOutPattern->substitute(assign);
  phpOutPattern->substitute(assign);
  return this;
};

ostream& SubstitutionRule::print(ostream& os) const{
      os << "SubstitutionRule - ";
      phpInPattern->print(os);
      //      tplOutPattern->print(os);
      return os;
};
