#ifndef _RTREESUBSTITUTIONRULE_H_
#define _RTREESUBSTITUTIONRULE_H_

#include "rulecontext.h"

/// Simple substitution rule.
/*!
  When phpInPattern matches the input, the out patterns are
  put to the out lists, with appropriate substitutions made.
*/
class SubstitutionRule : public Rule{
  /// php in pattern
  List* phpInPattern;
  /// tpl out pattern
  List* tplOutPattern;
  /// php out pattern
  List* phpOutPattern;
public:
  
  /// Constructor
  SubstitutionRule(List* iphpInPattern, List* itplOutPattern, List* iphpOutPattern) ;

  virtual bool execute(RuleContext* context, List* phpIn, List* phpOut, List* tplOut, Node::Assignment& assign) const;
  
  virtual Rule* copy();
  virtual Rule* substitute(const Node::Assignment &assign);
  
  virtual ostream& print(ostream& os) const;
};

#endif
