#include "rtreetriggeredrule.h"

TriggeredRule::TriggeredRule(PriorityRulePair* iinRulePair, PriorityRulePair* ioutRulePair) 
  : inRulePair(iinRulePair), outRulePair(ioutRulePair) {};

TriggeredRule::~TriggeredRule(){
  delete inRulePair->second;
  delete outRulePair->second;
  delete inRulePair;
  delete outRulePair;
};

bool TriggeredRule::execute(RuleContext* context, List* phpIn, List* phpOut, List* tplOut, Node::Assignment &assign)const{
  if (inRulePair->second->execute(context,phpIn,phpOut,tplOut,assign)){
    context->insert(outRulePair->first,outRulePair->second->copy()->substitute(assign));
    return true;
  } else return false;
};
  
Rule* TriggeredRule::copy(){
  return new TriggeredRule(new PriorityRulePair(inRulePair->first,inRulePair->second->copy()),
			   new PriorityRulePair(outRulePair->first,outRulePair->second->copy()));
};
Rule* TriggeredRule::substitute(const Node::Assignment &assign){
  inRulePair->second->substitute(assign);
  outRulePair->second->substitute(assign);
  return this;
};
  
ostream& TriggeredRule::print(ostream& os) const{
  os << "TriggeredRule - " << inRulePair->second;
  return os;
};
