#ifndef _RTREETRIGGEREDRULE_H_
#define _RTREETRIGGEREDRULE_H_

#include "rulecontext.h"

/// Inserts a rule into context, when other rule was successfully executed.
class TriggeredRule : public Rule{
  /// A rule to execute
  PriorityRulePair *inRulePair;
  /// When the rule inRulePair is successfully executed this rule is inserted into the context
  PriorityRulePair *outRulePair;
public:
  /// Constructor
  TriggeredRule(PriorityRulePair* iinRule, PriorityRulePair* ioutRule);

  virtual ~TriggeredRule();

  virtual bool execute(RuleContext* context, List* phpIn, List* phpOut, List* tplOut, Node::Assignment &assign) const;
  
  virtual Rule* copy();
  virtual Rule* substitute(const Node::Assignment &assign);
  
  virtual ostream& print(ostream& os) const;
};

#endif
