#include "rulesystem.h"
#include <stdio.h>
#include <dirent.h>

#include "stree.h"
#include "streeconstant.h"
#include "streepin.h"
#include "streevariable.h"
#include "treeparser.h"
#include "rtreenamedcontextrule.h"
#include "namedcontext.h"

/*!
\param phpIn -- tree of a file
\param tplName -- name of the generated template to be put in php code
\param phpOut -- refactored php codd
\param tplOut -- generated template
*/
void RuleSystem::execute(const string &phpFileName, StatementList *phpIn, StatementList *phpOut, StatementList *tplOut) {
  NamedContextRule mainRule(new Constant(MAINCONTEXTNAME), runRules[MAINCONTEXTNAME],
			    NULL, NULL, NULL, NULL, NULL);
  NameSpace fileNameSpace(&mainNameSpace);
  Node::Assignment assign;
  mainRule.runRules(fileNameSpace, phpIn, phpOut, tplOut, assign);
  mainNameSpace.importLocals(phpFileName, fileNameSpace);
};


RuleSystem::RuleSystem(int debug) {
//  debug = 1;
  DIR *rulesDir = opendir(MYRULES);
  struct dirent *rulesFile; 
  
  readdir(rulesDir);
  readdir(rulesDir);

  while ((rulesFile = readdir(rulesDir))){
    if (strcmp(rulesFile->d_name + strlen(rulesFile->d_name) - 3,"txt")==0){
      cout << "Parsing rules - " << rulesFile->d_name << endl;
      NamedRuleList* namedRuleList = 
	ruleParser->parse(string(MYRULES)+string(rulesFile->d_name),this, debug);
      
      runRules[namedRuleList->name][namedRuleList->runTime].append(namedRuleList->rules);
      ruleRunTimes.insert(namedRuleList->runTime);
    };
  };
  courrentRunTime = ruleRunTimes.begin();
};

bool RuleSystem::stepTime(){
  courrentRunTime++;
  if (courrentRunTime!=ruleRunTimes.end()){
    mainNameSpace.setRuleRunTime(*courrentRunTime);
    return true;
  } else 
    return false;
};

RuleSystem::~RuleSystem(){
  /*    NamedRunRuleList::iterator rulesIt = runRules.begin();
    NamedRunRuleList::iterator rulesEnd = runRules.end();
    while (rulesIt!=rulesEnd){
      delete rulesIt->second;
      rulesIt++;
      };    */
};

/*
void RuleSystem::insert(const string &contextName, int priority, Rule *rule){
    rules[contextName].insert(PriorityRulePair(priority,rule));
    };*/

/*
RunRuleList& RuleSystem::getRunRuleList(const string &contextName) { 
  NamedRunRuleList::iterator found = runRules.find(contextName);
  if (found != runRules.end())
    throw "ERROR: RuleSystem:getRunRuleList - context name " + contextName + " is not defined";
  else
    return found->second; 
    };*/ 
