#include "singlecontext.h"

SingleContext::SingleContext(RuleContext* isuperContext) : RuleContext(isuperContext->rules, isuperContext->nameSpace), superContext(isuperContext){};

SingleContext::SingleContext(RuleList &iruleList, RuleContext* isuperContext) : 
  RuleContext(iruleList, isuperContext->nameSpace), superContext(isuperContext){};

void SingleContext::generateVariableNames(const Node::VariableList &vlist, Node::Assignment &phpAssign, Node::Assignment &tplAssign){
    superContext->generateVariableNames(vlist,phpAssign,tplAssign);
};

const string SingleContext::getVariableNamePrefix(){
    return superContext->getVariableNamePrefix();
};

const string SingleContext::getVariableNameSufix(const bool stripControlVariableDollar){
    return superContext->getVariableNameSufix(stripControlVariableDollar);
};

const string SingleContext::generateVariableName(){
    return superContext->generateVariableName();
};

void SingleContext::registerSmartyVariable(const string &variable){
    superContext->registerSmartyVariable(variable);
};  

void SingleContext::processSmartyAssign(SmartyAssign *smartyAssign){
    superContext->processSmartyAssign(smartyAssign);
};  

void SingleContext::processTemplate(Node* tpl) const {
  superContext->processTemplate(tpl);
};

