#ifndef _SINGLECONTEXT_H_
#define _SINGLECONTEXT_H_
#include "rulecontext.h"

/// Context for a statements that are executed only once e.g in if. 
/*!
  In this context the names for variables can be taken from the super context. 
 */
class SingleContext : public RuleContext{  
  /// A pointer to super context.
  RuleContext *superContext;

 public:
  /// Constructor
  SingleContext(RuleContext* isuperContext);
  /// Constructor
  SingleContext(RuleList &iruleList, RuleContext* isuperContext);

  virtual void generateVariableNames(const Node::VariableList &vlist, Node::Assignment &phpAssign, Node::Assignment &tplAssign);

  virtual const string getVariableNamePrefix();

  virtual const string getVariableNameSufix(const bool stripControlVariableDollar);

  virtual const string generateVariableName();

  virtual void registerSmartyVariable(const string &variable);  

  virtual void processSmartyAssign(SmartyAssign *smartyAssign);  

  virtual void processTemplate(Node* tpl) const;
};

#endif
