#include "streeconstant.h"

ostream& Constant::print(ostream &os) const{
    return os << value;
};
  
ostream& Constant::php(ostream &os) const{
    return os << value;
}

bool Constant::match(const Node *p, Assignment &assign, const NameSpace  &nameSpace)const {
    if (p->getType()!=SConstant) return false;
    return ((Constant*)p)->getValue() == getValue();
};

bool Constant::matchToBegining(const List *p, Assignment &assign, const NameSpace &nameSpace) const{
  return false;
};

bool Constant::compare(const Node *p) const {
    if (p->getType()!=SConstant) return false;      
    return ((Constant*)p)->getValue() == getValue();
};
  
Node* Constant::substitute(const Assignment &assign){
    return this;
};
  
Node* Constant::copy() const {
    return new Constant(getValue());
};
  
void Constant::getVariables(VariableList &vlist) const{};

int Constant::toInt() const{
    istringstream is(getValue().c_str());
    int x;
    is >> x;
    return x;
}

string Constant::evaluate(const NameSpace &nameSpace) const{
  return getValue();
};
