#include "streenamedlist.h"

NamedList::NamedList(string name) : List(name){};
NamedList::NamedList(string name,Node *statement) : List(name){
    push_back(statement); 
};

Nullary::Nullary(string name) : List(name){};

ostream& Nullary::php(ostream &os) const{
    os << getName();
    return os;
};  

Node* Nullary::copy() const{
    return new Nullary(getName());
};

Unary::Unary(string name,Node* statement) : List(name){ 
    push_back(statement); 
};

Node* Unary::getStatement1() { 
    return *begin(); 
};

const Node* Unary::getStatement1() const{ 
    return *begin(); 
};


ostream& Unary::php(ostream &os) const{
    os << getName() << " " << getStatement1();
    return os;
};  

Node* Unary::copy() const{
    return new Unary(getName(),getStatement1()->copy());
};



Binary::Binary(string name,Node* statement1, Node* statement2) : List(name){ 
    push_back(statement1);
    push_back(statement2);
  };
  
Node* Binary::getStatement1() { 
    return *begin(); 
};

Node* Binary::getStatement2() { 
    return *(++begin()); 
};
  
const Node* Binary::getStatement1() const{ return *begin(); };
const Node* Binary::getStatement2() const{ return *(++begin()); };

ostream& Binary::php(ostream &os) const{
    os << getName() << " " << getStatement1() << " " << getStatement2();
    return os;
};  

Node* Binary::copy() const{
    return new Binary(getName(),getStatement1()->copy(),getStatement2()->copy());
};

Ternary::Ternary(string name,Node* statement1, Node* statement2, Node* statement3) 
    : List(name){
    push_back(statement1);
    push_back(statement2);
    push_back(statement3);
};
  
Node* Ternary::getStatement1() { return *begin(); };
Node* Ternary::getStatement2() { return *(++begin()); };
Node* Ternary::getStatement3() { return *(++++begin()); };
  
const Node* Ternary::getStatement1() const{ return *begin(); };
const Node* Ternary::getStatement2() const{ return *(++begin()); };
const Node* Ternary::getStatement3() const{ return *(++++begin()); };

ostream& Ternary::php(ostream &os) const{
    os << getName() << " " << getStatement1() << " " << getStatement2() << " " << getStatement3();
    return os;
};  

Node* Ternary::copy() const{
    return new Ternary(getName(),getStatement1()->copy(),getStatement2()->copy(),getStatement3()->copy());
};

Quadary::Quadary(string name,Node* statement1, Node* statement2, Node* statement3, Node* statement4) 
    : List(name){
    push_back(statement1);
    push_back(statement2);
    push_back(statement3);
    push_back(statement4);
};
  
Node* Quadary::getStatement1() { return *begin(); };
Node* Quadary::getStatement2() { return *(++begin()); };
Node* Quadary::getStatement3() { return *(++++begin()); };
Node* Quadary::getStatement4() { return *(++++++begin()); };
  
const Node* Quadary::getStatement1() const{ return *begin(); };
const Node* Quadary::getStatement2() const{ return *(++begin()); };
const Node* Quadary::getStatement3() const{ return *(++++begin()); };
const Node* Quadary::getStatement4() const{ return *(++++++begin()); };

ostream& Quadary::php(ostream &os) const{
    os << getName() << " " << getStatement1() << " " 
          << getStatement2() << " " << getStatement3()
          << " " << getStatement4();
    return os;
};  

Node* Quadary::copy() const{
    return new Quadary(getName(),getStatement1()->copy(),getStatement2()->copy(),getStatement3()->copy(),getStatement4()->copy());
};
