#include "streenode.h"
#include <sstream>

ostream& operator<<(ostream &os, const Node::Assignment &data){
      Node::Assignment::const_iterator it = data.begin();
      Node::Assignment::const_iterator eit = data.end();
      while (it!=eit){
	os << it->first << " " << it->second << endl;
	it++;
      };
      return os;
};

ostream& operator<<(ostream &os, const Node *data){
      return data->php(os);
};

string Node::toString() const{
  ostringstream str;
  str << this;
  return str.str();
};


Node* Node::push_back(Node *statement) {
      throw "push_back called for Node";
};

Node* Node::transform(const Transformer* transformer){
  return transformer->transform(this);
};

bool Node::forall(const Tester* tester, const NameSpace &nameSpace) const{
  return tester->test(this, nameSpace);
};

bool Node::exists(const Tester* tester, const NameSpace &nameSpace) const{
  return tester->test(this, nameSpace);
};

int Node::getLength() const{
  throw "getLength called for Node";
};

void substituteNode(Node* &node, const Node::Assignment &assign){
  Node *targ = node->substitute(assign);
  if (node!=targ) {
    delete node;
    node = targ;
  }
};
