#ifndef _STREE_PIN_
#define _STREE_PIN_

#include "streenode.h"

#define CPin "Pin"

/// A smart NULL.

class Pin : public Node
{
 public:
  /// Creates a Pin.
  Pin() {};
  
  virtual SType getType() const { return SPin; };
  
  virtual string getName() const { return CPin; };

  virtual ostream& print(ostream &os) const;
  
  virtual ostream& php(ostream &os) const;

  virtual bool match(const Node *p, Assignment &assign, const NameSpace &nameSpace)const;

  virtual bool matchToBegining(const List *p, Assignment &assign, const NameSpace &nameSpace) const;

  virtual bool compare(const Node *p) const;
  
  virtual Node* copy() const;

  virtual void getVariables(VariableList &vlist) const;

  virtual Node* substitute(const Assignment &assign);

  virtual string evaluate(const NameSpace &nameSpace) const;  
};

#endif
