#ifndef _STREE_VARIABLE_
#define _STREE_VARIABLE_

#include "streenode.h"
#include "streeconstant.h"


#define CVariable "Variable"

/// A Variable -- can be matched to other nodes. 
class Variable : public Node
{
  /// Identifier of the variable.
    int id;
public:
    /// Returns the identifier of the variable. 
    int getId() const { return id; };

    /// Creates Varable with given identifier.
    Variable(int iid);

    /// Creates Variable from constant by converting constant to int \sa Constant::toInt.
    Variable(Constant *name);

    /// Creates Variable from strnig by converting string to int.
    Variable(const string &name);

    virtual SType getType() const { return SVariable; };
    
    virtual string getName() const { return CVariable; };

    virtual ostream& print(ostream &os) const;

    virtual ostream& php(ostream &os) const;
    
    virtual bool match(const Node *p, Assignment &assign, const NameSpace &nameSpace) const;

    virtual bool matchToBegining(const List *p, Assignment &assign, const NameSpace &nameSpace) const;

    virtual bool compare(const Node *p) const;
    
    virtual Node* copy() const;

    virtual void getVariables(VariableList &vlist) const;

    virtual string evaluate(const NameSpace &nameSpace) const;  

 protected:

    virtual Node* substitute(const Assignment &assign);
};

#endif
