#include "tplconstantnormalizer.h"
#include "stree.h"
#include "streeconstant.h"

Node* TPLConstantNormalizer::transform(Node *node) const{
  if (node->getName() != CConstantString) return node;
  Constant* constant = dynamic_cast<Constant*>(((dynamic_cast<ConstantString*>(node))->getStatement1()));

  char* newstr = (char*)malloc(constant->getValue().length()+1);  
  char* t = newstr;
  const char* s =  constant->getValue().c_str();
  const char* end = s + constant->getValue().length();
  
  while (s<end) {
    if (*s=='\\') {
      s++;
      if (s>=end) {
	continue;
      }
      switch(*s) {
      case '\\':
      case '\'':
	*t++ = *s;
	break;
      default:
	*t++ = '\\';
	*t++ = *s;
	break;
      }
      s++;
    } else {
      *t++ = *s++;
    }
  }
  *t = 0;
  ConstantString *result = new ConstantString(new Constant(newstr));
  free(newstr);
  return result;
};
