#include "treeparser.h"

#include "streeconstant.h"
#include "streevariable.h"
#include "testers.h"
#include "rtreeactionrule.h"
#include "parser.tab.h"

extern int yyparse();
extern int yydebug;
extern void* yymyresult;
extern FILE* yyin;
extern ParseType parseRules;
extern RuleSystem* factor;
extern int yylineno;

void* XParser::parse(const string &fileName, ParseType iparseRules, RuleSystem *ifactor, bool iyydebug = 0){
  parseRules = iparseRules;
  yydebug = iyydebug;
  factor = ifactor;

  yylineno = 1;

  yyin = fopen(fileName.c_str(), "r");
  if (yyin == NULL) throw string("ERROR: XParser::parse - error opening file: ") 
		      +string(fileName);
  if (yyparse())
    throw "PARSE";
  fclose(yyin);
  return yymyresult;
};
