#ifndef _TREEPARSER_H_
#define _TREEPARSER_H_

#include "stree.h"
#include "rtree.h"
#include "rulesystem.h"

enum ParseType {ParseRules, ParsePHP, ParseNormalizers };

/// Encapsulates the parser
class XParser{
 protected:
  void* parse(const string &fileName, ParseType iparseRules, RuleSystem *ifactor, bool iyydebug);
};
/// Parser for rules
class RuleParser : public XParser{
 public:
  NamedRuleList* parse(const string &fileName, 
		       RuleSystem *factor,
		       bool iyydebug = 0) { 
    return (NamedRuleList*)(XParser::parse(fileName,ParseRules,factor,iyydebug)); 
  };
};
/// Parser for php files
class PHPParser : public XParser{
 public:
  StatementList* parse(const string &fileName, bool iyydebug = 0) { 
    return (StatementList*)(XParser::parse(fileName,ParsePHP,NULL,iyydebug)); 
  };
};

static RuleParser* ruleParser = new RuleParser();
static PHPParser* phpParser = new PHPParser();

#endif
